
#  $Date: 1996/07/20 14:53:29 $ $Author: stefanw $ $Revision: 1.9 $   #



faclib::truncate:=proc(p,k)
  local i;
begin
if iszero(p) then return(p); end_if;
if nterms(p)=1 then 
        if degree(p)<k then return(p) else return(p-p);  end_if;
end_if;
_plus(select(nthmonomial(p, i) $ hold(i)=1..nterms(p),
        fun(degree(args(1)) < k)));

end_proc:


faclib::multifactor:=proc(f)
local i,j,l,F,xx,factlist,result;
begin
 if type(f)<>DOM_POLY then error("not a polynomial") end_if;
 xx:=op(f,2);
 if nops(xx)<2 then error("multivariate polynomial expected"); end_if;
 F:=op(f,3);
   if F::hasProp(Cat::Field)<>TRUE then
         error("coefficient ring should be a field")
   end_if;
l:=faclib::pre_factor(f);
result:=[op(l,1)];
for i from 2 to nops(l) step 2 do
	if nops(op(l,[i,2]))=1 then 
		factlist:=factor(op(l,i));
	else
		factlist:=faclib::mufactor(op(l,i));
	end_if;
	result[1]:=result[1]*factlist[1];
	for j from 3 to nops(factlist) step 2 do
		factlist[j]:=factlist[j]*op(l,i+1);
	end_for;
	if op(l,[i,2])<>xx then
		for j from 2 to nops(factlist) step 2 do
			factlist[j]:=subsop(factlist[j],2=xx);
		end_for;
	end_if;
	result:=result.[op(factlist,2..nops(factlist))];
end_for;
result
end_proc:

faclib::mufactor:=proc(f)
local l,F,factlist,result,i,j,st;

begin
 F:=op(f,3);  
  st:=time();
  l:=sqrfree(f);
  userinfo(2,"Time for squarefree factorization:".expr2text(time()-st));
   result:=[op(l,1)];
   for i from 2 to nops(l) step 2 do
        factlist:=faclib::multihensel(op(l,i));
        result:=result.[(op(factlist,j),op(l,i+1)) $hold(j)=1..nops(factlist) ];
    end_for;
    result
end_proc:


# If f \in F[x1,..,xn] , f primitive,
  and I is the ideal generated by x2,..,xn,
  multihensel computes a factorization of f #
# by first computing a factorization modulo I^d, where
  d is ''big enough'' #
  # Note that a polynomial is an element of I^k iff any of its
    coefficients with respect to x1 has total degree >= k w.r.t. x2,..,xn #

faclib::multihensel:=proc(f)
local ff,f0,fi,R,X,y,df,q,a,e,r,s,t,fprod,g,h,i,j,k,evpoints,
	iindets,nindets,F,d,lc,st,factorsleft,setleft,factlist;

begin
iindets:=op(f,2);
nindets:=nops(op(f,2));
# as f is primitive, if it has degree =1 with respect to one variable,
  it must be irreducible #
if has([degree(f,iindets[i]) $hold(i)=1..nindets],1) then
	 userinfo(2,"Irreducible by degree argument");
	 return([f]);
end_if;

# exchange variables if f has zero derivative #
# as f is squarefree, this cannot happen for all variables #
i:=0;
repeat
	i:=i+1;
until not iszero(D([i],f)) end_repeat;
X:=op(iindets,1);
if i>1 then
	nindets:=iindets;
	iindets[1]:=iindets[i];
	iindets[i]:=X;
	g:=subsop(f,2=iindets);
	return(map(faclib::multihensel(g),fun(subsop(args(1),2=nindets))));
end_if;	
userinfo(2,"Using ".expr2text(X)." as main variable");
F:=op(f,3);
R:=Dom::DistributedPolynomial([op(iindets,2..nindets)],F);
evpoints:=array(2..nindets);
# try whether zero is good evaluation point #
f0:=evalp(f,iindets[i]=F::zero $hold(i)=2..nindets);
ff:=sqrfree(f0);
if degree(f0)=degree(f,X) and nops(ff)=3 and op(ff,3)=1 then
	for i from 2 to nindets do
	 	evpoints[i]:=F::zero; 
	end_for;
	userinfo(2,"Zero is suitable evaluation point");
	ff:=poly(f,[X],R);
elif nindets>2 or (F::constructor<>Dom::IntegerMod 
    and F::constructor<>Dom::GaloisField) then
	st:=time();
	repeat
		for i from 2 to nindets do
			evpoints[i]:=F::random();
		end_for;
		f0:=evalp(f,iindets[i]=evpoints[i] $hold(i)=2..nindets);
		ff:=sqrfree(f0);
	until degree(f0)=degree(f,X) and nops(ff)=3 and op(ff,3)=1 end_repeat;
	userinfo(2,"Time needed for choosing evaluation points:".expr2text(time()-st));

	ff:=poly(subs(expr(f),iindets[i]=iindets[i]+expr(evpoints[i])
 	$hold(i)=2..nindets),	[X],R);
else  # finite field #
	ff:=poly(f,[X],R);
	 a:=lcoeff(ff);
	 y:=op(iindets,2);
	  q:=(if F::constructor=Dom::GaloisField then 
                F::size
          else
                F::characteristic
          end_if
        );

	df:=Dpoly(ff);
	 g:=resultant(ff,df);
     
    	 h:=R(y^q-y);
     
                # as y^q-y is the product of all linear polynomials,
                  (y^q-y)/gcd(y^q-y,resultant(f,df)) is the product
                   of all (y-c) where c runs through all suitable
                   evaluation points; they can be found by factoring #
        
        g:=divide(h,gcd(h,g),hold(Exact));
        g:=divide(g,gcd(g,a),hold(Exact));

                # only non-roots of a remain #

	if degree(g)=0 then 
                # bad luck : there is no good evaluation point #
                # field has to be extended; if an extension of prime 
                  degree > max(m,n) is chosen, the factorization remains
                  the same 
                  (see v.z.Gathen, Factoring Sparse Multivariate Polynomials,
                   Proc. 24th Symp. Found. Comp. Sci.,IEEE, 1983, pp.172-179) #
        
                q:=nextprime(max(degree(f,X),degree(f,y))+1);
                userinfo(2,"Field does not contain good evaluation point");
                userinfo(2,"Constructing extension of degree",q);
                
                f:=poly(f,Dom::GaloisField(F,q));
                g:=faclib::multihensel(f);
                for i from 1 to nops(g) do
			g[i]:=subsop(op(g,i),3=F);
		end_for;
                return(g);
        else     
		userinfo(3,"Number of good evaluation points: "
				.expr2text(degree(g)));
		if degree(g) > q/4 then  
			# many good points, try random choice  #
			repeat 
				evpoints[2]:=F::random()
			until evalp(g,y=evpoints[2])=F::zero end_repeat;
			userinfo(3,"Found evaluation point by random choice");
			userinfo(3,"Evaluation point is ".
					expr2text(evpoints[2]));
		else    
                	h:=faclib::eqdegr(poly(g,[y],F),1,1);
                	evpoints[2]:=-coeff(h,0);
			userinfo(3,"Choosing evaluation point: "
			.expr2text(evpoints[2]));
                # simply choose the first factor found (anyone would be o.k) #
		end_if;

		f0:=evalp(f,iindets[2]=evpoints[2]);
		ff:=poly(subs(expr(f),iindets[2]=iindets[2]+expr(evpoints[2])
 		),	[X],R);
        end_if

end_if;
lc:=lcoeff(ff);
st:=time();
fi:=factor(f0);
userinfo(2,"Time for univariate factorization:".expr2text(time()-st));
if nops(fi)=3 then 
	userinfo(2,"Even homomorphic image is irreducible");
	return([f]); 
else
	userinfo(2,"Homomorphic image has "
		.expr2text(nops(fi) div 2)." factors");
end_if;
t:=op(fi,1);
fi:=[op(fi,2*j) $hold(j)=1..nops(fi) div 2];
fi[1]:=multcoeffs(fi[1],t);
# find s1 ... sn #

# if u*(f1*..fk)+v*(f(k+1))=1 and s1*(f2* ...*fk)+ ... + sk*(f1*...*f(k-1))=1
  then set s(k+1):=u and multiply the other si by v #

st:=time();
fprod:=fi[1]*fi[2];
t:=gcdex(fi[2],fi[1]);  # sic! #
s:=[ op(t,2..3) ];
# loop invariant: fprod = f1 * ... * fj #
for j from 3 to nops(fi) do 
	t:=gcdex(fprod,fi[j]);
	for k from 1 to j-1 do
		s[k]:=s[k]*op(t,3);
	end_for;
	s:=append(s,op(t,2)); 
	fprod:=fprod*fi[j];
end_for;
 s:=zip(s,fi,fun(divide(args(1),args(2),hold(Rem)))); 

userinfo(2,"Time for determining the si: ".expr2text(time()-st));

# transform to polynomials over R #
for j from 1 to nops(fi) do 
	fi[j]:=poly(fi[j],[X],R);
	s[j]:=poly(s[j],[X],R);
end_for;

d:=max(map(coeff(ff),degree))+1;
userinfo(2,"Lifting up to order ".expr2text(d));
st:=time();
for j from 2 to d do
		userinfo(3,"Lifting to order ".expr2text(j));
		e:=mapcoeffs(ff-_mult(op(fi)),fun(faclib::truncate(args(1),j)));  
	for i from 2 to nops(fi) do 
		q[i]:=divide(e*s[i],fi[i]);
		r[i]:=mapcoeffs(op(q[i],2),fun(faclib::truncate(args(1),j)));
		q[i]:=mapcoeffs(op(q[i],1),fun(faclib::truncate(args(1),j)));
		fi[i]:=fi[i]+r[i];
	end_for;
	# i = 1 #
	r[1]:=mapcoeffs(s[1]*e+fi[1]*(_plus(q[k] $hold(k)=2..nops(fi))),
		fun(faclib::truncate(args(1),j)));
	fi[1]:=fi[1]+r[1];
end_for;
userinfo(2,"Time for Hensel lifting: ".expr2text(time()-st));

userinfo(3,"Result of lifting:",fi);	

# try to combine operands of fi to obtain a factorization #

factorsleft:=[op(fi,2..nops(fi))];
factlist:=[];

repeat
	r:=faclib::tryall(ff,factorsleft,lc,d);
	if op(r,1)=[] then
		factorsleft:=[op(factorsleft,2..nops(factorsleft))];
	else
		factlist := factlist.op(r,1);
		userinfo(2,"Factor found:",op(r,1));
		ff:=divide(ff,_mult(op(op(r,1))),hold(Exact));
		if ff=FAIL then error("factor not correct"); end_if;
		setleft:={j $hold(j)=1..nops(factorsleft)} minus op(r,2);
		factorsleft:=[op(factorsleft,op(setleft,j))
		 $hold(j)=1..nops(setleft)];
	end_if
until factorsleft=[] end_repeat;
if factlist=[] then 
	return([f])
else
   	factlist:=append(factlist,ff); 
	return(map(factlist,fun(poly(subs(expr(args(1)),
		iindets[i]=iindets[i]-expr(evpoints[i]) $hold(i)=2..nindets),
		op(f,2..3)))));
end_if
end_proc:


faclib::tryall:=proc(f,flist,lc,d)
# tests whether multiplying some members member of flist, including the first,
  and lc modulo I^d 
  gives a factor of f #
# returns a list of factors that can be obtained this way, and a set
  containing the indices of those operands of flist that were used to build up
  these factors #
local g,h,j,l;

begin
userinfo(4,"faclib::tryall called with",flist);

h:=mapcoeffs(multcoeffs(flist[1],lc),fun(faclib::truncate(args(1),d)));
l:=primpart(h);
g:=divide(f,l,hold(Exact));
if g<>FAIL then
	# factor found #
return([[l],{1}]);
else
        for j from 2 to nops(flist) do
		l:=flist[1]*flist[j];
		g:=faclib::tryall(f,[l].[op(flist,j+1..nops(flist))],lc,d);
		if op(g,1)<>[] then 
			return([op(g,1),{1,j} union 
				map(op(g,2) minus {1} ,fun(args(1)+j))]);
	        end_if;
	end_for;
end_if;	
[[],{}]
end_proc:
